%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% EXAMPLE.PRG
% Applies Structural Break Tests and P-Value Computations

% Bruce E. Hansen
% Department of Economics
% Social Science Building
% University of Wisconsin
% Madison, WI 53706-1393
% bhansen@ssc.wisc.edu
% http://www.ssc.wisc.edu/~bhansen/
function example()
out=fopen('example.txt','wt');
ar=6;
t=595;
load gmpy.txt;
dat=gmpy;
d=dat(3:t+2);
d=log(d);
dy=d(2:t)-d(1:t-1);
y=dy(1+ar:t-1);
x=ones(t-1-ar,1);
i=1;
while i<=ar
    x=[x,dy(1+ar-i:t-1-i)];
    i=i+1;
end;
[k,supf,expf,avef]=st_ch(y,x,.15,.85,1);
fprintf(out,'Monthly Personal Income\n');
fprintf(out,'Sample Period:  %f  %f\n',dat(1),dat(2));
fprintf(out,'AR(6) Model\n\n');

stat=[supf(1,:);expf(1,:);avef(1,:)];
fprintf(out,'Test            Stat         P-Value\n');
fprintf(out,'SupLM         %f   %f\n',stat(1,1),stat(1,2));
fprintf(out,'ExpLM         %f   %f\n',stat(2,1),stat(2,2));
fprintf(out,'AveLM         %f   %f\n',stat(3,1),stat(3,2));
fprintf(out,'\n\n\n');
ar=12;
t=583;
load fygm3.txt;
dat=fygm3;
d=dat(3:t+2);
dy=d(2:t)-d(1:t-1);
y=dy(1+ar:t-1);
x=ones(t-1-ar,1);
i=1;
while i<=ar
    x=[x,dy(1+ar-i:t-1-i)];
    i=i+1;
end;
[k,supf,expf,avef]=st_ch(y,x,.15,.85,1);
fprintf(out,'3-Month T-Bill Rate\n');
fprintf(out,'Sample Period:  %f  %f\n',dat(1),dat(2));
fprintf(out,'AR(12) Model\n\n');

stat=[supf(1,:);expf(1,:);avef(1,:)];
fprintf(out,'Test            Stat         P-Value\n');
fprintf(out,'SupLM         %f   %f\n',stat(1,1),stat(1,2));
fprintf(out,'ExpLM         %f   %f\n',stat(2,1),stat(2,2));
fprintf(out,'AveLM         %f   %f\n',stat(3,1),stat(3,2));
